#include<iostream>
#include<set>
#include<vector>
#include<time.h>
#include<algorithm>
#include<fstream>
#include<string>

#define ZREBOVANYCH 20 //cisel

#define TYPOVANYCH 5 //cisel
#define NASOBOK 200 //pre 5 cisel

#define CENA 0.50 //centov

#define MAX_CISLO 80

#define BUFF 128
#define CSV 23

using namespace std;

void print(int *pole, int size, bool show_index = false);
void copy(int *pole, int *pole2, int size);
bool nachadza(int *pole, int size, int cislo);
void nahodne(int *pole, int size);
int sum(int *pole, int size);

class Keno10{
public:
	float vklad;
	float vyhra;
	int tahov;
	int vkladov;
	int vyhier;

	int actual_line;

	bool show;
	bool show2;
	int zrebovane[ZREBOVANYCH];
	fstream subor;

	Keno10(bool show = false, bool show2 = false):vklad(0), vyhra(0), tahov(0), vkladov(0), vyhier(0), actual_line(0), show(show), show2(show2){
		srand(time(NULL));
		subor.open("keno10.csv");

		char nic[128];
		if(!subor.is_open())
			cout << "Subor sa neda otvorit." << endl;
		else
			subor.getline(nic, 128);//posun o jeden riadok za hlavicku
	}

	int uhadol(int *typ, int *zrebovane){
		int uhadol = 0;

		for(int i = 0; i < ZREBOVANYCH; i++){
			for(int j = 0; j < TYPOVANYCH; j++){
				if(zrebovane[i] == typ[j])
					uhadol++;
			}
		}

		return uhadol;
	}

	void zrebuj(){
		int cisla[ZREBOVANYCH] = {72,6,64,55,36,23,48,20,25,29,28,31,66,11,18,22,65,59,47,27};
		copy(zrebovane, cisla, ZREBOVANYCH);
		sort(zrebovane, zrebovane+ZREBOVANYCH);

		tahov++;

		if(show){
			cout << "Vyzrebovane cisla:" << endl;
			print(zrebovane, ZREBOVANYCH);
			cout << endl;
		}
	}

	void vyhraj(int uhadol){
		int nasobok[TYPOVANYCH+1] = {0, 0, 0, 2, 16, 200};
		vyhra += CENA * nasobok[uhadol];
		if(nasobok[uhadol] > 0)
			vyhier++;
	}

	void test(){ //nahodne typovanie na jednom tahu
		int typ[TYPOVANYCH];
		nahodne(typ, TYPOVANYCH);
		sort(typ, typ+TYPOVANYCH);

		vklad += CENA;
		vkladov++;

		int uhadol_cisel = 0;
		uhadol_cisel = uhadol(typ, zrebovane);

		vyhraj(uhadol_cisel);

		if(show2){
			cout << "Uhadol:" << endl << uhadol_cisel << endl;

			cout << "Typovane cisla:" << endl;
			print(typ, TYPOVANYCH);	
		}
	}

	void test2(int *typ, int from = 0){ //typovanie na vsetkych tahoch s konkretnymi cislami
		sort(typ, typ+TYPOVANYCH);

		if(actual_line >= from){
			vklad += CENA;
			vkladov++;
		}

		int uhadol_cisel = 0;
		nacitaj_tah(zrebovane, from);
		if(actual_line < from)
			return;

		uhadol_cisel = uhadol(typ, zrebovane);

		vyhraj(uhadol_cisel);

		if(show2){
			cout << "Zrebovane cisla: " << endl;
			print(zrebovane, ZREBOVANYCH);
			cout << "Uhadol:" << uhadol_cisel << endl;
		}
	}

	void nacitaj_tah(int *tah, int from = 0){
		int j = 0;
		string riadok;
		
		for(int i = 0; i < CSV; i++){
			if(i == CSV-1)
				getline(subor, riadok, '\n');
			else
				getline(subor, riadok, ';');
			if(i >= 3){
				tah[j] = atoi(riadok.c_str());
				j++;
			}
		}
		actual_line++;
		if(actual_line >= from)
			tahov++;
	}

	void stats(int from = 0){
		string riadok;
		int tah[ZREBOVANYCH];

		vector<int> sumy;
		int frekvencia[MAX_CISLO+1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		
		while(subor.good()){
			int j = 0;
			actual_line++;
			for(int i = 0; i < CSV; i++){
				if(i == CSV-1)
					getline(subor, riadok, '\n');
				else
					getline(subor, riadok, ';');
				if(i >= 3){
					tah[j] = atoi(riadok.c_str());
					if(tah[j] == 0)
						continue;
					if(actual_line >= from)
						frekvencia[tah[j]]++;
					j++;
				}
			}

			if(actual_line >= from)
				sumy.push_back(sum(tah, ZREBOVANYCH));


		}

		cout << "Frekvncia: " << endl;
		print(frekvencia, MAX_CISLO+1, true);
	}

	void reset(){
		//subor.seekg(0, ios::end);
		subor.close();
		subor.open("keno10.csv");
		char nic[128];
		if(subor.is_open())
			subor.getline(nic, 128);//posun o jeden riadok za hlavicku

		actual_line = 0;
	}

	void vypis(){
		cout << endl;
		cout << "Vklad:" << vklad << endl;
		cout << "Vyhra:" << vyhra << endl;
		cout << "Cista vyhra(vyhra-vklad):" << vyhra-vklad << endl;
		cout << "Vkladov:" << vkladov << endl;
		cout << "Vyhier:" << vyhier << endl;
		cout << "Tahov:" << tahov << endl;
		cout << "Uspesnost(vyhra/vklad): " << (vyhra/vklad)*100 << "%" << endl;
		cout << "Uspesnost2(vyhier/vkladov): " << (float)((float)vyhier/(float)vkladov)*100 << "%" << endl;
	}
};

int main(){
	Keno10 keno(1, 0);
	
	/*keno.zrebuj();
	for(int i = 0; i < 1000000; i++){
		srand(time(NULL)*271828+i);
		keno.test();
	}*/
	int typ[TYPOVANYCH];

	cout << "Autor: Jorg > jorg.pavol@gmail.com" << endl;
	cout << "Zadajte 5 typovanych cisel:";
	for(int i = 0; i < TYPOVANYCH; i++)
		cin >> typ[i];

	cout << "Typovane:" ;
	print(typ, TYPOVANYCH);
	cout << endl;

	for(int i = 0; i < 4876; i++)
		keno.test2(typ, 0);
	
	keno.vypis();

	keno.reset();

	cout << endl;
	cout << "Najviac padane cisla od roku 1999 po rok 2012: " << endl;
	keno.stats(0);
	
	fflush(stdin);
	getchar();
	return 0;
}

void print(int *pole, int size, bool show_index){
	for(int i = 0; i < size; i++){
		if(show_index)
			cout << "[" << i << "] ";
		cout << pole[i] << ",";

	}
	cout << endl;
}

void copy(int *pole, int *pole2, int size){
	for(int i = 0; i < size; i++)
		pole[i] = pole2[i];
}

bool nachadza(int *pole, int size, int cislo){
	for(int i = 0; i < size; i++)
		if(pole[i] == cislo)
			return true;

	return false;
}

void nahodne(int *pole, int size){
	int cislo;
	for(int i = 0; i < size; i++){
		cislo = rand() % MAX_CISLO + 1;
		//if(cislo%4 == 0){i--; continue;}
		if(!nachadza(pole, size, cislo))
			pole[i] = cislo;
		else
			i--;
	}
}

int sum(int *pole, int size){
	int suma = 0;
	for(int i = 0; i < size; i++)
		suma += pole[i];
	return suma;
}